# class IRB::Locale

### Constants

LOCALE_DIR
LOCALE_NAME_RE

### Attributes

lang[R]
modifier[R]
territory[R]

### Public Class Methods

new(locale = nil) click to toggle source

    # File lib/irb/locale.rb, line 26
    def initialize(locale = nil)
      @override_encoding = nil
      @lang = @territory = @encoding_name = @modifier = nil
      @locale = locale || ENV["IRB_LANG"] || ENV["LC_MESSAGES"] || ENV["LC_ALL"] || ENV["LANG"] || "C"
      if m = LOCALE_NAME_RE.match(@locale)
        @lang, @territory, @encoding_name, @modifier = m[:language], m[:territory], m[:codeset], m[:modifier]

        if @encoding_name
          begin load 'irb/encoding_aliases.rb'; rescue LoadError; end
          if @encoding = @@legacy_encoding_alias_map[@encoding_name]
            warn(("%s is obsolete. use %s" % ["#{@lang}_#{@territory}.#{@encoding_name}", "#{@lang}_#{@territory}.#{@encoding.name}"]), uplevel: 1)
          end
          @encoding = Encoding.find(@encoding_name) rescue nil
        end
      end
      @encoding ||= (Encoding.find('locale') rescue Encoding::ASCII_8BIT)
    end

### Public Instance Methods

String(mes) click to toggle source
Calls superclass method `Kernel#String`

    # File lib/irb/locale.rb, line 50
    def String(mes)
      mes = super(mes)
      if encoding
        mes.encode(encoding, undef: :replace)
      else
        mes
      end
    end

encoding() click to toggle source

    # File lib/irb/locale.rb, line 46
    def encoding
      @override_encoding || @encoding
    end

find(file , paths = $:) click to toggle source

    # File lib/irb/locale.rb, line 125
    def find(file , paths = $:)
      dir = File.dirname(file)
      dir = "" if dir == "."
      base = File.basename(file)

      if dir.start_with?('/')
        return each_localized_path(dir, base).find{|full_path| File.readable? full_path}
      else
        return search_file(paths, dir, base)
      end
    end

format(*opts) click to toggle source
Calls superclass method `Kernel#format`

    # File lib/irb/locale.rb, line 59
    def format(*opts)
      String(super(*opts))
    end

gets(*rs) click to toggle source
Calls superclass method `Kernel#gets`

    # File lib/irb/locale.rb, line 63
    def gets(*rs)
      String(super(*rs))
    end

load(file, priv=nil) click to toggle source

    # File lib/irb/locale.rb, line 113
    def load(file, priv=nil)
      found = find(file)
      if found
        unless @@loaded.include?(found)
          @@loaded << found # cache
          return real_load(found, priv)
        end
      else
        raise LoadError, "No such file to load -- #{file}"
      end
    end

Also aliased as: toplevel_load
print(*opts) click to toggle source
Calls superclass method `Kernel#print`

    # File lib/irb/locale.rb, line 71
    def print(*opts)
      ary = opts.collect{|opt| String(opt)}
      super(*ary)
    end

printf(*opts) click to toggle source

    # File lib/irb/locale.rb, line 76
    def printf(*opts)
      s = format(*opts)
      print s
    end

puts(*opts) click to toggle source
Calls superclass method `Kernel#puts`

    # File lib/irb/locale.rb, line 81
    def puts(*opts)
      ary = opts.collect{|opt| String(opt)}
      super(*ary)
    end

readline(*rs) click to toggle source
Calls superclass method `Kernel#readline`

    # File lib/irb/locale.rb, line 67
    def readline(*rs)
      String(super(*rs))
    end

require(file, priv = nil) click to toggle source
Calls superclass method `Kernel#require`

    # File lib/irb/locale.rb, line 86
    def require(file, priv = nil)
      rex = Regexp.new("lc/#{Regexp.quote(file)}\.(so|o|sl|rb)?")
      return false if $".find{|f| f =~ rex}

      case file
      when /\.rb$/
        begin
          load(file, priv)
          $".push file
          return true
        rescue LoadError
        end
      when /\.(so|o|sl)$/
        return super
      end

      begin
        load(f = file + ".rb")
        $".push f  #"
        return true
      rescue LoadError
        return ruby_require(file)
      end
    end

toplevel_load(file, priv=nil)
Alias for: load

### Private Instance Methods

each_localized_path(dir, file) { |nil? ? join(dir, LOCALE_DIR, file) : join(dir, LOCALE_DIR, lc, file)| ... } click to toggle source

    # File lib/irb/locale.rb, line 164
    def each_localized_path(dir, file)
      return enum_for(:each_localized_path) unless block_given?
      each_sublocale do |lc|
        yield lc.nil? ? File.join(dir, LOCALE_DIR, file) : File.join(dir, LOCALE_DIR, lc, file)
      end
    end

each_sublocale() { |"#{lang}_#{territory}.#{encoding_name}@#{modifier}"| ... } click to toggle source

    # File lib/irb/locale.rb, line 171
    def each_sublocale
      if @lang
        if @territory
          if @encoding_name
            yield "#{@lang}_#{@territory}.#{@encoding_name}@#{@modifier}" if @modifier
            yield "#{@lang}_#{@territory}.#{@encoding_name}"
          end
          yield "#{@lang}_#{@territory}@#{@modifier}" if @modifier
          yield "#{@lang}_#{@territory}"
        end
        if @encoding_name
          yield "#{@lang}.#{@encoding_name}@#{@modifier}" if @modifier
          yield "#{@lang}.#{@encoding_name}"
        end
        yield "#{@lang}@#{@modifier}" if @modifier
        yield "#{@lang}"
      end
      yield nil
    end

real_load(path, priv) click to toggle source

    # File lib/irb/locale.rb, line 138
    def real_load(path, priv)
      src = MagicFile.open(path){|f| f.read}
      if priv
        eval("self", TOPLEVEL_BINDING).extend(Module.new {eval(src, nil, path)})
      else
        eval(src, TOPLEVEL_BINDING, path)
      end
    end

search_file(lib_paths, dir, file) click to toggle source

@param paths load paths in which `IRB` find a localized file. @param dir directory @param file basename to be localized

typically, for the parameters and a <path> in paths, it searches

    <path>/<dir>/<locale>/<file>

    # File lib/irb/locale.rb, line 153
    def search_file(lib_paths, dir, file)
      each_localized_path(dir, file) do |lc_path|
        lib_paths.each do |libpath|
          full_path = File.join(libpath, lc_path)
          return full_path if File.readable?(full_path)
        end
        redo if defined?(Gem) and Gem.try_activate(lc_path)
      end
      nil
    end